fun{States InitStack InitStore}
   S='||'('||'(nil state(stack:nil store:nil) S)
	  state(stack:{Map InitStack ExpressSemInstr} store:{ExpressStore InitStore} trans:load)
	  {Next S InitStack InitStore})in
   S
end
fun lazy {Next E Stack Store}
   Trans
   NS={Step Stack Store Trans}
   R='||'(E {Convert NS Store Trans} {Next R NS Store}) in
   R
end
fun{Convert Stack Store Trans}
   case Stack
   of exception(_) then
      state(stack:[{ExpressSemInstr Stack}] store:{ExpressStore Store} trans:Trans)
   else
      state(stack:{Map Stack ExpressSemInstr} store:{ExpressStore Store} trans:Trans)
   end
end
fun{ExpressSemInstr IS}
   case IS
   of exception(A) then
      txt("Abnormal termination, uncaught exception: "#A)
   [] I#E then
      pair({EncStatement I ""}
	   {EncEnv E ""})
   end
end
fun{Incr I}I#"   "end
fun{EncId I}I end
fun{EncLit L}
   if {IsAtom L} then "'"#{Atom.toString L}#"'"
   elseif {IsInt L} then {Int.toString L}
   elseif L==unit then "unit"
   elseif L==true then "true"
   elseif L==false then "false"
   end
end
fun{EncRec R}
   case R
   of unit(...) then
      "unit("#{MapToTuple {Arity R} fun{$ X}
				       {EncLit X}#":"#{EncId R.X}#" "
				    end}#")"
   [] true(...) then
      "true("#{MapToTuple {Arity R} fun{$ X}
				       {EncLit X}#":"#{EncId R.X}#" "
				    end}#")"
   [] false(...) then
      "false("#{MapToTuple {Arity R} fun{$ X}
					{EncLit X}#":"#{EncId R.X}#" "
				     end}#")"
   else
      "'"#{Atom.toString {Label R}}#"'("#{MapToTuple {Arity R} fun{$ X}
								  {EncLit X}#":"#{EncId R.X}#" "
							       end}#")"
   end
end
fun{EncStatement I Ind}
   case I
   of kSkip then "skip"
   [] kAnd(S1 S2) then {EncStatement S1 Ind}#"\n"#Ind#{EncStatement S2 Ind}
   [] kRaise(k(A)) then "raise "#{EncLit A}#" end"
   [] kRaise(Id) then "raise "#{EncId Id}#" end"
   [] kLocal(Id S) then
      "local "#{EncId Id}#" in\n"#
      {Incr Ind}#{EncStatement S {Incr Ind}}#"\n"#
      Ind#"end"
   [] kIf(Id S1 S2) then
      "if "#{EncId Id}#" then\n"#
      {Incr Ind}#{EncStatement S1 {Incr Ind}}#"\n"#
      Ind#"else\n"#
      {Incr Ind}#{EncStatement S2 {Incr Ind}}#"\n"#
      Ind#"end"
   [] kCase(Id P S1 S2) then
      "case "#{EncId Id}#" of "#{EncRec P}#" then\n"#
      {Incr Ind}#{EncStatement S1 {Incr Ind}}#"\n"#
      Ind#"else\n"#
      {Incr Ind}#{EncStatement S2 {Incr Ind}}#"\n"#
      Ind#"end"
   [] kTry(S1 Id S2) then
      "try\n"#
      {Incr Ind}#{EncStatement S1 {Incr Ind}}#"\n"#
      Ind#"catch "#{EncId Id}#" then\n"#
      {Incr Ind}#{EncStatement S2 {Incr Ind}}#"\n"#
      Ind#"end"
   [] kCatch(Id S) then
      "catch "#{EncId Id}#" then\n"#
      {Incr Ind}#{EncStatement S {Incr Ind}}#"\n"#
      Ind#"end"
   [] kApply(Id Ids) then
      "{"#{EncId Id}#{MapToTuple Ids fun{$X}" "#{EncId X}end}#"}"
   [] kVarVar(I J) then
      {EncId I}#"="#{EncId J}
   [] kVarOp1(I O J) then
      {EncId I}#"="#O#{EncId J}
   [] kVarOp2(I O J K) then
      {EncId I}#"="#{EncId J}#O#{EncId K}
   [] kVarOp3(I _ J K L) then
      {EncId I}#"="#{EncId J}#"."#{EncId K}#":="#{EncId L}
   [] kVarVal(I KProc(Fs S _)) then
      {EncId I}#"=proc{$"#{MapToTuple Fs fun{$X}" "#{EncId X}end}#"}\n"#
      {Incr Ind}#{EncStatement S {Incr Ind}}#"\n"#
      Ind#"end"
   [] kVarVal(I V) andthen {IsAtom V} then
      {EncId I}#"='"#{Atom.toString V}#"'"
   [] kVarVal(I V) andthen {IsInt V} then
      {EncId I}#"="#{Int.toString V}
   [] kVarVal(I V) andthen {IsFloat V} then
      {EncId I}#"="#{Float.toString V}
   [] kVarVal(I unit) then
      {EncId I}#"=unit"
   [] kVarVal(I true) then
      {EncId I}#"=true"
   [] kVarVal(I false) then
      {EncId I}#"=false"
   [] kVarVal(I V) andthen {IsRecord V} then
      {EncId I}#"="#{EncRec V}
   end
end
local
   VarNames={NewDictionary}
   CurInd={NewCell 0}
in
   fun{EncVar V}
      if {HasFeature VarNames V} then VarNames.V else
	 VarNames.V:={VirtualString.toString "v"#{Int.toString CurInd:=@CurInd+1}}
	 VarNames.V
      end
   end
end
local
   CellNames={NewDictionary}
   CurInd={NewCell 0}
in
   fun{EncCellId V}
      if {HasFeature CellNames V} then CellNames.V else
	 CellNames.V:={VirtualString.toString "c"#{Int.toString CurInd:=@CurInd+1}}
	 CellNames.V
      end
   end
end
fun{EncEnv E Ind}
   if{Dictionary.isEmpty E} then "{ }"
   elseif {Length {Dictionary.keys E}}==1 then
      [I#V]={Dictionary.entries E} in
      "{"#{EncId I}#" -> "#{EncVar V}#"}"
   else
      "{\n"#{MapToTuple {Dictionary.entries E} fun{$ I#V}
						  Ind#" "#{EncId I}#" -> "#{EncVar V}#"\n"
					       end}#Ind#"}"
   end
end
fun{MapToTuple L F}
   case L
   of nil then nil
   [] [A] then {F A}
   [] H|T then {F H}#{MapToTuple T F}
   end
end
fun{ExpressStore S}
   Memo=memo(...) in
   for X in {Filter {RecordC.reflectArity S} IsName} collect:C do
      if {Not{Member X {RecordC.reflectArity Memo}}} then
	 EqC={Filter {RecordC.reflectArity S.X} fun{$ X}X\=unit end}
	 Txt={ExprEqClass EqC}
      in
	 for X in EqC do Memo^X=unit end
	 if {IsDet S.X.unit} then
	    V=S.X.unit in
	    if {IsLiteral V} orelse {IsInt V} then
	       {C Txt#" = "#{EncLit V}}
	    elseif {IsFloat V} then
	       {C Txt#" = "#{Float.toString V}}
	    else
	       case V
	       of RecVal(R) then
		  {C Txt#" = "#{ExprRecVal R}}
	       [] ProcVal(F S CE) then
		  Ind=for I in 1..{VirtualString.length Txt}+3 collect:C do {C & }end in
		  {C
		   Txt#" = (proc{$"#{MapToTuple F fun{$X}" "#{EncId X}end}#"}\n"#
		   {Incr Ind}#" "#{EncStatement S {Incr Ind}#" "}#"\n"#
		   Ind#" end\n"#
		   Ind#",\n"#
		   Ind#" "#{EncEnv CE Ind#" "}#"\n"#
		   Ind#")"}
	       [] BIVal(name:N ...) then
		  {C Txt#" = <Builtin: "#N#">"}
	       [] CellVal(I Ce) then
		  {C Txt#" = <Cell: "#{EncCellId I}#">\n"#{EncCellId I}#" ==> "#{EncVar @Ce}}
	       end
	    end
	 else
	    {C Txt}
	 end
      end
   end
end
fun{ExprEqClass E}
   case E
   of [A] then {EncVar A}
   [] H|T then {EncVar H}#"="#{ExprEqClass T}
   end
end
fun{ExprRecVal R}
   {EncLit {Label R}}#"("#{MapToTuple {Arity R} fun{$ X}
						   {EncLit X}#":"#{EncVar R.X}#" "
						end}#")"
end