fun{Step Stack Store Trans}
   case Stack
   of (kSkip#_)|T then Trans='skip'
      T
   [] [kRaise(k(A))#_] then Trans='uncaught'
      exception(A)
   [] [kRaise(Id)#E] then Trans='uncaught'
      exception(Store.(E.Id).unit)
   [] (kRaise(k(A))#_)|(kCatch(Id2 S)#E2)|T then Trans='catch'
      (S#{AdjoinAtEnv E2 Id2 {VarOf Store A}})|T
   [] (kRaise(Id1)#E1)|(kCatch(Id2 S)#E2)|T then Trans='catch'
      (S#{AdjoinAtEnv E2 Id2 E1.Id1})|T
   [] ((kRaise(...)#_)=X)|_|T then Trans='unwind'
      X|T
   [] (kAnd(S1 S2)#E)|T then Trans='and'
      (S1#E)|(S2#E)|T
   [] (kLocal(Id S)#E)|T then
      X={NewName} in
      Trans='local'
      Store^X=var(unit:_ X:unit ...)
      (S#{AdjoinAtEnv E Id X})|T
   [] (kIf(Id S1 S2)#E)|T then
      C=Store.(E.Id).unit in
      if {IsDet C} then
	 case C
	 of true then Trans='iftrue' (S1#E)|T
	 [] false then Trans='iffalse' (S2#E)|T
	 else Trans='ifbad' (kRaise(k('Non-boolean arbiter'))#E)|T
	 end
      else
	 (stop(Id)#E)|Stack
      end
   [] (kCase(Id P S1 S2)#E)|T then
      C=Store.(E.Id).unit in
      if {IsDet C} then
	 if {Label C}=={Label P} andthen {Arity C}=={Arity P} then
	    Trans='casethen'
	    (S1#{AdjoinEnv E
		 for
		    I in {Arity C}
		    collect:Col
		 do
		    {Col (P.I)#(C.I)}
		 end})|T   
	 else
	    Trans='caseelse'
	    (S2#E)|T
	 end
      else
	 (stop(Id)#E)|Stack
      end
   [] (kTry(P1 Id P2)#E)|T then
      Trans='try'
      (P1#E)|(kCatch(Id P2)#E)|T
   [] (kCatch(_ _)#_)|T then
      Trans='catchnoexcept'
      T
   [] (kApply(Id Ids)#E)|T then
      P=Store.(E.Id).unit in
      if {IsDet P} then
	 case P
	 of ProcVal(FIds S CE) andthen {Length FIds}=={Length Ids} then
	    NE=
	    {AdjoinEnv CE
	     for
		I in Ids
		F in FIds
		collect:C
	     do
		{C F#E.I}
	     end} in
	    Trans='apply'
	    (S#NE)|T
	 [] ProcVal(_ _ _) then
	    Trans='applybadarity'
	    (kRaise(k('Invalid argument count'))#E)|T
	 [] BIVal(code:C arity:N ...) andthen N=={Length Ids} then
	    {C Ids E Store T Trans}
	 [] BIVal(...) then
	    Trans='applyBIbadarity'
	    (kRaise(k('Invalid argument count'))#E)|T
	 else
	    Trans='applybad'
	    (kRaise(k('Applying non-procedure'))#E)|T
	 end
      else
	 (stop(Id)#E)|Stack
      end
   [] (kVarVal(Id KProc(FormIds S FreeIds))#E)|T then
      P=Store.(E.Id).unit in
      if {IsDet P} then
	 Trans='uniferror'
	 (kRaise(k('Unification error'))#E)|T
      else
	 Trans='procdecl'
	 P=ProcVal(FormIds S {RestrictEnv E FreeIds})
	 T
      end
   [] (kVarVal(Id  X)#E)|T andthen {IsLiteral X}orelse {IsInt X} then
      V=Store.(E.Id).unit in
      if {IsDet V} andthen V\=X then
	 Trans='uniferror'
	 (kRaise(k('Unification error'))#E)|T
      else
	 L= Store^literals^X in
	 Trans='cstdecl'
	 if{Not{IsDet L}}then L=E.Id end
	 V=X
	 T
      end
   [] (kVarVal(Id  X)#E)|T andthen {IsFloat X} then
      V=Store.(E.Id).unit in
      if {IsDet V} andthen V\=X then
	 Trans='uniferror'
	 (kRaise(k('Unification error'))#E)|T
      else
	 Trans='cstdecl'
	 V=X
	 T
      end
   [] (kVarVal(Id X)#E)|T then
      V=Store.(E.Id).unit in
      if {IsDet V} then
	 case V
	 of RecVal(R) andthen {Label R}=={Label X} andthen {Arity R}=={Arity X} then
	    ({Unify Store E.Id {Record.map X fun{$ F} E.F end} Trans}#E)|T
	 else
	    Trans='uniferror'
	    (kRaise(k('Unification error'))#E)|T
	 end
      else
	 R={Record.clone X}in
	 Trans='recdecl'
	 for I in {Arity X} do
	    R.I=E.(X.I)
	 end
	 V=RecVal(R)
	 T
      end
   [] (kVarVar(Id1 Id2)#E)|T then
      V1=Store.(E.Id1).unit
      V2=Store.(E.Id2).unit in
      if {IsDet V1} andthen {IsDet V2} andthen V1\=V2 then
	 ({Unify Store E.Id1 E.Id2 Trans}#E)|T
      else
	 Trans='vardecl'
	 Store.(E.Id1)=Store.(E.Id2)
	 T
      end
   [] (kVarOp1(Id1 Op Id2)#E)|T then
      {Store.ops.Op.opcode [Id1 Id2] E Store T Trans}
   [] (kVarOp2(Id1 Op Id2 Id3)#E)|T then
      {Store.ops.Op.opcode [Id1 Id2 Id3] E Store T Trans}
   [] (kVarOp3(Id1 Op Id2 Id3 Id4)#E)|T then
      {Store.ops.Op.opcode [Id1 Id2 Id3 Id4] E Store T Trans}
   end
end
ProcVal={NewName}
RecVal={NewName}
BIVal={NewName}
fun{VarOf Store A}
   X=Store^literals^A in
   if{IsDet X} then X else X={NewName} Store^X=var(unit:A X:unit ...) X end
end
fun{AdjoinAtEnv E I X}
   NE={Dictionary.clone E} in
   NE.I:=X
   NE
end
fun{AdjoinEnv E L}
   NE={Dictionary.clone E} in
   for I#X in L do
      NE.I:=X
   end
   NE
end
fun{RestrictEnv E L}
   NE={NewDictionary} in
   for I in L do
      NE.I:=E.I
   end
   NE
end
fun{Unify Store V1 V2 Trans}
   fun{UnifyL Cs}
      case Cs
      of nil then Trans='unifok' Store^unit=Memo kSkip
      [] boum then Trans='uniferror' kRaise(k('unification error'))
      [] (V1#V2)|T then NT in
	 if {IsDet Store.V1.unit} andthen {IsDet Store.V2.unit} andthen Store.V1.unit\=Store.V2.unit then
	    if {IsDet Memo^V1^V2} then
	       NT=T
	    else
	       Memo^V1^V2=unit
	       Memo^V2^V1=unit
	       case (Store.V1.unit)#(Store.V2.unit)
	       of RecVal(R1)#RecVal(R2) andthen {Label R1}=={Label R2} andthen {Arity R1}=={Arity R2} then
		  NT={Append
		      for
			 I in {Arity R1}
			 collect:C
		      do
			 {C (R1.I)#(R2.I)}
		      end
		      T}
	       else
		  NT=boum
	       end
	    end
	 else
	    Store.V1=Store.V2
	    NT=T
	 end
	 {UnifyL NT}
      end
   end
   Memo
in
   {UnifyL [V1#V2]}
end