declare
KProc={NewName}
fun{ListTails L}
   case L
   of nil then nil
   [] _|T then L|{ListTails T}
   end
end
fun{ParseStatement Text R}
   if {ParseSkip Text R} then true
   elseif {ParseRaise Text R} then true
   elseif {ParseLocal Text R} then true 
   elseif {ParseIf Text R} then true
   elseif {ParseCase Text R} then true
   elseif {ParseTry Text R} then true
   elseif {ParseApply Text R} then true
   elseif {ParseEq Text R} then true
   else false
   end
end
fun{ParseStatements Text R} A B in
   if {ParseStatement Text A} then
      if {ParseStatements A.2 B} then R=kAnd(A.1 B.1)#B.2 true
      else R=A true
      end
   else
      false
   end
end
fun{ParseSkip Text R}
   case Text
   of kwSkip|T then R=kSkip#T true
   else false
   end
end
fun{ParseRaise Text R}
   case Text
   of kwRaise|id(I)|kwEnd|T then R=kRaise(I)#T true
   else false
   end
end
fun{ParseLocal Text R}
   case Text
   of kwLocal|id(I)|kwIn|T then A in
      if {ParseStatements T A} then
	 case A.2
	 of kwEnd|T then
	    R=kLocal(I A.1)#T true
	 else
	    false
	 end
      else
	 false
      end
   else false
   end
end
fun{ParseIf Text R}
   case Text
   of kwIf|id(I)|kwThen|T then A in
      if {ParseStatements T A} then
	 case A.2
	 of kwElse|T then B in
	    if {ParseStatements T B} then
	       case B.2
	       of kwEnd|T then
		  R=kIf(I A.1 B.1)#T true
	       else
		  false
	       end
	    else
	       false
	    end
	 else
	    false
	 end
      else
	 false
      end
   else false
   end
end
fun{ParseCase Text R}
   case Text
   of kwCase|id(I)|kwOf|T then A in
      if {ParseRec T A} then
	 case A.2
	 of kwThen|T then B in
	    if {ParseStatements T B} then
	       case B.2
	       of kwElse|T then C in
		  if{ParseStatements T C} then
		     case C.2
		     of kwEnd|T then
			R=kCase(I A.1 B.1 C.1)#T true
		     else
			false
		     end
		  else
		     false
		  end
	       else
		  false
	       end
	    else
	       false
	    end
	 else
	    false
	 end
      else
	 false
      end
   else false
   end
end
fun{ParseTry Text R}
   case Text
   of kwTry|T then A in
      if {ParseStatements T A} then
	 case A.2
	 of kwCatch|id(I)|kwThen|T then B in
	    if {ParseStatements T B} then
	       case B.2
	       of kwEnd|T then
		  R=kTry(A.1 I B.1)#T true
	       else
		  false
	       end
	    else
	       false
	    end
	 else
	    false
	 end
      else
	 false
      end
   else false
   end
end
fun{ParseApply Text R}
   case Text
   of kwLBrace|id(I)|T then TT in
      case
	 for
	    E in T
	    CT in {ListTails T}
	    collect:C
	    break:B
	    return:R
	 do
	    case E
	    of id(I) then {C I}
	    [] kwRBrace then TT=CT.2 {B}
	    else {R false}
	    end
	 end
      of false then
	 false
      [] L then
	 R=kApply(I L)#TT true
      end
   else false
   end
end
fun{ParseRec Text R}
   fun{Loop T Fs NT}
      case T
      of atom(A)|kwColon|id(I)|T then NFs in
	 Fs=(A#I)|NFs
	 {Loop T NFs NT}
      [] int(J)|kwColon|id(I)|T then NFs in
	 Fs=(J#I)|NFs
	 {Loop T NFs NT}
      [] kwRPar|T then
	 Fs=nil
	 NT=T
      end
   end
in
   case Text
   of label(A)|kwLPar|T then Fs NT in
      if {Loop T Fs NT} then
	 R={MakeRecord A {Map Fs fun{$X}X.1 end}}#NT
	 for F#I in Fs do
	    R.F=I
	 end
	 true
      else false
      end
   else false
   end
end
fun{ParseEq Text R}
   case Text
   of id(I)|kwEq|int(J)|T then
      R=kVarVal(I J)#T true
   [] id(I)|kwEq|atom(J)|T then
      R=kVarVal(I J)#T true
   [] id(I)|kwEq|float(J)|T then
      R=kVarVal(I J)#T true
   [] id(I)|kwEq|kwProc|kwLBrace|kwDollar|T then TT in
      case
	 for
	    E in T
	    CT in {ListTails T}
	    collect:C
	    break:B
	    return:R
	 do
	    case E
	    of id(I) then {C I}
	    [] kwRBrace then TT=CT.2 {B}
	    else {R false}
	    end
	 end
      of false then
	 false
      [] L then A in
	 if {ParseStatements TT A} then
	    case A.2
	    of kwEnd|T then
	       R=kVarVal(I KProc(L A.1 {Filter {FreeVars A.1} fun{$X}{Not{Member X L}}end}))#T true
	    else false
	    end
	 else false
	 end
      end
   [] id(I)|kwEq|op1(O)|id(J)|T then
      R=kVarOp1(I O J)#T true
   [] id(I)|kwEq|id(J)|op2(O)|id(K)|T then
      R=kVarOp2(I O J K)#T true
   [] id(I)|kwEq|id(J)|op2('.')|id(K)|op2(':=')|id(L)|T then
      R=kVarOp3(I '.:=' J K L)#T true
   [] id(I)|kwEq|id(J)|T then
      R=kVarVar(I J)#T true
   [] id(I)|kwEq|T then A in
      if {ParseRec T A} then
	 R=kVarVal(I A.1)#A.2 true
      else false
      end
   else false
   end
end
fun{FreeVars X}
   case X
   of kSkip then nil
   [] kRaise(Id) then [Id]
   [] kAnd(S1 S2) then {Append {FreeVars S1} {FreeVars S2}}
   [] kLocal(Id S) then {Filter {FreeVars S} fun{$ X}X\=Id end}
   [] kIf(Id S1 S2) then Id|{Append {FreeVars S1} {FreeVars S2}}
   [] kCase(Id P S1 S2) then A={Record.toList P} in Id|{Append {Filter {FreeVars S1} fun{$X}{Not{Member X A}}end}{FreeVars S2}}
   [] kTry(S1 Id S2) then {Append {FreeVars S1} {Filter {FreeVars S2} fun{$X}X\=Id end}}
   [] kApply(Id Ids) then Id|Ids
   [] kVarVar(I J) then [I J]
   [] kVarOp1(I _ J) then [I J]
   [] kVarOp2(I _ J K) then [I J K]
   [] kVarOp3(I _ J K L) then [I J K L]
   [] kVarVal(I KProc(_ _ FVs)) then I|FVs
   [] kVarVal(I V) andthen {IsRecord V} then
      I|{Record.toList V}
   [] kVarVal(I _) then [I]
   end
end
fun{NotInAtom X}
   {Not {Char.isAlNum X} orelse X==&_}
end
fun{LexFloat T TT}
   float({String.toFloat
	  for C in T L in {ListTails T} collect:Col break:B do
	     if {Char.isDigit C} then {Col C}
	     elseif {Member C ".eE~"} then {Col C}
	     else TT=L {B}
	     end
	  end})
end
fun{LexNum T TT}
   case T
   of &~|&0|A|T1 andthen A==&x orelse A==&X then X in
      X=
      for
	 C in T1
	 L in {ListTails T1}
	 collect:Col
	 break:B
      do
	 if {Char.isXDigit C} then {Col C}
	 else TT=L {B}
	 end
      end
      int({StringToInt &~|&0|A|X})
   [] &0|A|T1 andthen A==&b orelse A==&B then X in
      X=
      for
	 C in T1
	 L in {ListTails T1}
	 collect:Col
	 break:B
      do
	 if {Char.isXDigit C} then {Col C}
	 else TT=L {B}
	 end
      end
      int({StringToInt &0|A|X})
   [] &~|&0|A|T1 andthen A==&b orelse A==&B then X in
      X=
      for
	 C in T1
	 L in {ListTails T1}
	 collect:Col
	 break:B
      do
	 if C==&0 orelse C==&1 then {Col C}
	 else TT=L {B}
	 end
      end
      int({StringToInt &~|&0|A|X})
   [] &0|A|T1 andthen A==&b orelse A==&B then X in
      X=
      for
	 C in T1
	 L in {ListTails T1}
	 collect:Col
	 break:B
      do
	 if C==&0 orelse C==&1 then {Col C}
	 else TT=L {B}
	 end
      end
      int({StringToInt &0|A|X})
   [] &~|&0|T1 then X in
      X=
      for
	 C in T1
	 L in {ListTails T1}
	 collect:Col
	 break:B
	 return:R
      do
	 case C
	 of &. then {R float}
	 [] &8 then {R float}
	 [] &9 then {R float}
	 else
	    if {Char.isDigit C} then {Col C}
	    else TT=L {B}
	    end
	 end
      end
      if X==float then {LexFloat T TT} else int({StringToInt &~|&0|X}) end
   [] &0|T1 then X in
      X=
      for
	 C in T1
	 L in {ListTails T1}
	 collect:Col
	 break:B
	 return:R
      do
	 case C
	 of &. then {R float}
	 [] &8 then {R float}
	 [] &9 then {R float}
	 else
	    if {Char.isDigit C} then {Col C}
	    else TT=L {B}
	    end
	 end
      end
      if X==float then {LexFloat T TT} else int({StringToInt &0|X}) end
   [] &~|T1 then X in
      X=
      for
	 C in T1
	 L in {ListTails T1}
	 collect:Col
	 break:B
	 return:R
      do
	 case C
	 of &. then {R float}
	 else
	    if {Char.isDigit C} then {Col C}
	    else TT=L {B}
	    end
	 end
      end
      if X==float then {LexFloat T TT} else int({StringToInt &~|X}) end
   [] T1 then X in
      X=
      for
	 C in T1
	 L in {ListTails T1}
	 collect:Col
	 break:B
	 return:R
      do
	 case C
	 of &. then {R float}
	 else
	    if {Char.isDigit C} then {Col C}
	    else TT=L {B}
	    end
	 end
      end
      if X==float then {LexFloat T TT} else int({StringToInt X}) end
   end
end
fun{HexVal X}
   if X-&0>9 then
      if X-&a>5 then
	 X-&A+10
      else
	 X-&a+10
      end
   else
      X-&0
   end
end
fun{IsOct X}
   X>=&0 andthen X=<&7
end
fun{LexId T TT}
   id({String.toAtom for
			C in T
			L in {ListTails T}
			collect:Col
			break:B
		     do
			if {Char.isAlNum C} then {Col C}
			else TT=L {B}
			end
		     end})
end
fun{LexDelId T TT}
   fun{Loop L}
      case L
      of &`|T then TT=T [&`]
      [] &\\|&a|T then &\a|{Loop T}
      [] &\\|&b|T then &\b|{Loop T}
      [] &\\|&f|T then &\f|{Loop T}
      [] &\\|&n|T then &\n|{Loop T}
      [] &\\|&r|T then &\r|{Loop T}
      [] &\\|&t|T then &\t|{Loop T}
      [] &\\|&v|T then &\v|{Loop T}
      [] &\\|&\\|T then &\\|{Loop T}
      [] &\\|&'|T then &'|{Loop T}
      [] &\\|&"|T then &"|{Loop T}
      [] &\\|&`|T then &`|{Loop T}
      [] &\\|&&|T then &&|{Loop T}
      [] &\\|A|B|C|T andthen {IsOct A} andthen {IsOct B} andthen {IsOct C} then
	 ((A-&0)*64+(B-&0)*8+(C-&0))|{Loop T}
      [] &\\|&x|A|B|T andthen {Char.isXDigit A} andthen {Char.isXDigit B} then
	 ({HexVal A}*16+{HexVal B})|{Loop T}
      [] &\\|&X|A|B|T andthen {Char.isXDigit A} andthen {Char.isXDigit B} then
	 ({HexVal A}*16+{HexVal B})|{Loop T}
      [] H|T then H|{Loop T}
      end
   end
in
   id({String.toAtom &`|{Loop T}})
end
fun{LexDelAtom T TT}
   K
   fun{Loop L}
      case L
      of &'|&(|T then K=label TT=&(|T nil
      [] &'|T then K=atom TT=T nil
      [] &\\|&a|T then &\a|{Loop T}
      [] &\\|&b|T then &\b|{Loop T}
      [] &\\|&f|T then &\f|{Loop T}
      [] &\\|&n|T then &\n|{Loop T}
      [] &\\|&r|T then &\r|{Loop T}
      [] &\\|&t|T then &\t|{Loop T}
      [] &\\|&v|T then &\v|{Loop T}
      [] &\\|&\\|T then &\\|{Loop T}
      [] &\\|&'|T then &'|{Loop T}
      [] &\\|&"|T then &"|{Loop T}
      [] &\\|&`|T then &`|{Loop T}
      [] &\\|&&|T then &&|{Loop T}
      [] &\\|A|B|C|T andthen {IsOct A} andthen {IsOct B} andthen {IsOct C} then
	 ((A-&0)*64+(B-&0)*8+(C-&0))|{Loop T}
      [] &\\|&x|A|B|T andthen {Char.isXDigit A} andthen {Char.isXDigit B} then
	 ({HexVal A}*16+{HexVal B})|{Loop T}
      [] &\\|&X|A|B|T andthen {Char.isXDigit A} andthen {Char.isXDigit B} then
	 ({HexVal A}*16+{HexVal B})|{Loop T}
      [] H|T then H|{Loop T}
      end
   end
   A={String.toAtom {Loop T}}
in
   K(A)
end
fun{Lex Text}
   case Text
   of &{|T then kwLBrace|{Lex T}
   [] &}|T then kwRBrace|{Lex T}
   [] &)|T then kwRPar|{Lex T}
   [] &(|T then kwLPar|{Lex T}
   [] &+|T then op2('+')|{Lex T}
   [] &-|T then op2('-')|{Lex T}
   [] &*|T then op2('*')|{Lex T}
   [] &/|T then op2('/')|{Lex T}
   [] &d|&i|&v|A|T andthen {NotInAtom A} then op2('div')|{Lex T}
   [] &m|&o|&d|A|T andthen {NotInAtom A} then op2('mod')|{Lex T}
   [] &.|T then op2('.')|{Lex T}
   [] &:|&=|T then op2(':=')|{Lex T}
   [] &@|T then op1('@')|{Lex T}
   [] &=|&=|T then op2('==')|{Lex T}
   [] &\\|&=|T then op2('\\=')|{Lex T}
   [] &=|&<|T then op2('=<')|{Lex T}
   [] &>|&=|T then op2('>=')|{Lex T}
   [] &<|T then op2('<')|{Lex T}
   [] &>|T then op2('>')|{Lex T}
   [] &=|T then kwEq|{Lex T}
   [] &:|T then kwColon|{Lex T}
   [] &$|T then kwDollar|{Lex T}
   [] &s|&k|&i|&p|A|T andthen {NotInAtom A} then kwSkip|{Lex A|T}
   [] &r|&a|&i|&s|&e|A|T andthen {NotInAtom A} then kwRaise|{Lex A|T}
   [] &e|&n|&d|A|T andthen {NotInAtom A} then kwEnd|{Lex A|T}
   [] &l|&o|&c|&a|&l|A|T andthen {NotInAtom A} then kwLocal|{Lex A|T}
   [] &i|&n|A|T andthen {NotInAtom A} then kwIn|{Lex A|T}
   [] &i|&f|A|T andthen {NotInAtom A} then kwIf|{Lex A|T}
   [] &t|&h|&e|&n|A|T andthen {NotInAtom A} then kwThen|{Lex A|T}
   [] &e|&l|&s|&e|A|T andthen {NotInAtom A} then kwElse|{Lex A|T}
   [] &c|&a|&s|&e|A|T andthen {NotInAtom A} then kwCase|{Lex A|T}
   [] &o|&f|A|T andthen {NotInAtom A} then kwOf|{Lex A|T}
   [] &t|&r|&y|A|T andthen {NotInAtom A} then kwTry|{Lex A|T}
   [] &c|&a|&t|&c|&h|A|T andthen {NotInAtom A} then kwCatch|{Lex A|T}
   [] &p|&r|&o|&c|A|T andthen {NotInAtom A} then kwProc|{Lex A|T}
   [] &t|&r|&u|&e|&(|T then label(true)|kwLPar|{Lex T}
   [] &t|&r|&u|&e|A|T andthen {NotInAtom A} then atom(true)|{Lex A|T}
   [] &f|&a|&l|&s|&e|&(|T then label(falsee)|kwLPar|{Lex T}
   [] &f|&a|&l|&s|&e|A|T andthen {NotInAtom A} then atom(false)|{Lex A|T}
   [] &u|&n|&i|&t|&(|T then label(unit)|kwLPar|{Lex T}
   [] &u|&n|&i|&t|A|T andthen {NotInAtom A} then atom(unit)|{Lex A|T}
   [] &'|T then TT in {LexDelAtom T TT}|{Lex TT}
   [] &`|T then TT in {LexDelId T TT}|{Lex TT}
   [] H|T andthen {Char.isUpper H} then TT in {LexId H|T TT}|{Lex TT}
   [] H|T andthen {Char.isDigit H} then TT in {LexNum H|T TT}|{Lex TT}
   [] &~|H|T andthen {Char.isDigit H} then TT in {LexNum H|T TT}|{Lex TT}
   [] &~|T then op1('~')|{Lex T}
   [] H|T andthen {Char.isSpace H} then {Lex T}
   [] nil then nil
   end
end
